import 'dart:io';

import 'package:flutter/foundation.dart';
import 'package:flutter/material.dart';
import 'package:flutter_local_notifications/flutter_local_notifications.dart';
import 'package:permission_handler/permission_handler.dart';

class NotificationManger {
  // private constructor to avoid create object
  NotificationManger._();

  static FlutterLocalNotificationsPlugin localNotificationsPlugin; //= FlutterLocalNotificationsPlugin();

  /// initialisation setting for all platform
  /// onNotificationPressed action when notification pressed to open tap
  /// onIOSNotificationPressed action when notification pressed
  /// to open tap in iOS versions older than 10
  Future<void> requestPermissions() async {

  }
  static initialisation(Function(NotificationResponse) onNotificationPressed, DidReceiveLocalNotificationCallback onIOSNotificationPressed) async {
    FlutterLocalNotificationsPlugin _flutterLocalNotificationsPlugin = FlutterLocalNotificationsPlugin();
    // initialise the plugin. app_icon needs to be a added as a drawable resource to the Android head project
    const AndroidInitializationSettings initializationSettingsAndroid = AndroidInitializationSettings('@drawable/ic_stat_name');

    final DarwinInitializationSettings initializationSettingsDarwin = DarwinInitializationSettings(onDidReceiveLocalNotification: onIOSNotificationPressed);

    final InitializationSettings initializationSettings = InitializationSettings(android: initializationSettingsAndroid, iOS: initializationSettingsDarwin, macOS: initializationSettingsDarwin);
    localNotificationsPlugin = _flutterLocalNotificationsPlugin;

    if (Platform.isIOS) {
      await localNotificationsPlugin.resolvePlatformSpecificImplementation<IOSFlutterLocalNotificationsPlugin>()?.requestPermissions(alert: true, badge: true, sound: true);
    } else if (Platform.isAndroid) {
      AndroidFlutterLocalNotificationsPlugin androidImplementation = localNotificationsPlugin.resolvePlatformSpecificImplementation<AndroidFlutterLocalNotificationsPlugin>();
      bool granted = await androidImplementation?.requestPermission();
      granted = granted ?? false;
      if (granted == false) {
        if (kDebugMode) {
          print("-------------------- Permission Granted ------------------------");
          print(granted);
        }
        await Permission.notification.request();
      }
    }

    await localNotificationsPlugin.initialize(initializationSettings, onDidReceiveNotificationResponse: onNotificationPressed);
    //localNotificationsPlugin = flutterLocalNotificationsPlugin;
  }



  // push new notificationBuildContext
  static Future showNotification({@required context, @required String title, @required String subtext, @required int hashcode, String payload}) async {
    const AndroidNotificationDetails androidChannel = AndroidNotificationDetails(
      'com.hmg.atoms',
      'ATOMS',
      channelDescription: 'Push notification service for ATOMS',
      importance: Importance.max,
      priority: Priority.max,
      icon: "@drawable/ic_stat_name",
      playSound: true,
      channelShowBadge: true,
      // enableLights: false,
      visibility: NotificationVisibility.public,
      //ledColor: Theme.of(context).colorScheme.secondary,
      // ledOnMs: 1,
      // ledOffMs: 0,
      enableVibration: true,
      groupKey: 'com.hmg.atoms',
    );

    const DarwinNotificationDetails iosNotificationDetails = DarwinNotificationDetails(
      categoryIdentifier: "atoms",
    );

    const platformChannel = NotificationDetails(android: androidChannel, iOS: iosNotificationDetails, macOS: iosNotificationDetails);

    await localNotificationsPlugin.show(hashcode, title, subtext, platformChannel, payload: payload);
  }
}
